---
title: "Excel Import"
framework: javascript
version: "36.1.0"
---

# Excel Import

Below we illustrate how you might import an Excel spreadsheet into AG Grid using a third-party library - in this example we're using [xlsx](https://www.jsdelivr.com/package/npm/xlsx).

[Auto-Generate Columns](https://www.ag-grid.com/javascript-data-grid/auto-generate-columns/) is used so no column definitions need to be provided upfront — columns are created from the imported data. The `processFileInput` callback parses dropped Excel files using the same library.

Click **Load Sample Excel** to fetch a sample spreadsheet, or drag your own `.xlsx` file onto the grid. Click **Upload File** to re-show the file input overlay. The spreadsheet can also be downloaded [here](https://www.ag-grid.com/example-assets/olympic-data.xlsx).

## Example Import

#### Import Excel into AG Grid

```ts
import {
  AutoGenerateColumnsModule,
  ClientSideRowModelModule,
  GridApi,
  GridOptions,
  ModuleRegistry,
  ProcessFileInputParams,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ContextMenuModule,
  ExcelExportModule,
} from "ag-grid-enterprise";

declare let XLSX: any;

// Enable extended validations only for development
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  AutoGenerateColumnsModule,
  ExcelExportModule,
  ColumnMenuModule,
  ContextMenuModule,
]);

let gridApi: GridApi;

const gridOptions: GridOptions = {
  autoGenerateColumnDefs: true,

  defaultColDef: {
    minWidth: 80,
    flex: 1,
  },

  processFileInput: (params: ProcessFileInputParams) => {
    const file = params.files[0];
    if (!file) return;
    const reader = new FileReader();
    reader.onerror = () => params.fail("Failed to read file");
    reader.onload = (e) => {
      try {
        const workbook = XLSX.read(
          new Uint8Array(e.target?.result as ArrayBuffer),
        );
        params.success(parseWorkbook(workbook));
      } catch {
        params.fail("Failed to parse file");
      }
    };
    reader.readAsArrayBuffer(file);
  },
};

function parseWorkbook(workbook: any): Record<string, unknown>[] {
  const firstSheetName = workbook.SheetNames[0];
  const worksheet = workbook.Sheets[firstSheetName];
  return XLSX.utils.sheet_to_json(worksheet);
}

function uploadFile() {
  const curr = gridApi.getGridOption("activeOverlay");
  gridApi.setGridOption(
    "activeOverlay",
    curr === "agFileInputOverlay" ? undefined : "agFileInputOverlay",
  );
}

function importExcel() {
  fetch("https://www.ag-grid.com/example-assets/olympic-data.xlsx")
    .then((response) => response.arrayBuffer())
    .then((data: ArrayBuffer) => {
      const workbook = XLSX.read(new Uint8Array(data));
      gridApi.updateGridOptions({
        rowData: parseWorkbook(workbook),
        activeOverlay: undefined,
      });
    });
}

const eGridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(eGridDiv, gridOptions);

if (typeof window !== "undefined") {
  // Attach external event handlers to window so they can be called from index.html
  (<any>window).uploadFile = uploadFile;
  (<any>window).importExcel = importExcel;
}
```

[Live example: Import Excel into AG Grid](https://www.ag-grid.com/examples/excel-import/excel-import/typescript/)


---
title: "Excel Import"
framework: react
version: "36.1.0"
---

# Excel Import

Below we illustrate how you might import an Excel spreadsheet into AG Grid using a third-party library - in this example we're using [xlsx](https://www.jsdelivr.com/package/npm/xlsx).

[Auto-Generate Columns](https://www.ag-grid.com/react-data-grid/auto-generate-columns/) is used so no column definitions need to be provided upfront — columns are created from the imported data. The `processFileInput` callback parses dropped Excel files using the same library.

Click **Load Sample Excel** to fetch a sample spreadsheet, or drag your own `.xlsx` file onto the grid. Click **Upload File** to re-show the file input overlay. The spreadsheet can also be downloaded [here](https://www.ag-grid.com/example-assets/olympic-data.xlsx).

## Example Import

#### Import Excel into AG Grid

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import "./styles.css";
import {
  AutoGenerateColumnDefsOptions,
  AutoGenerateColumnsModule,
  ClientSideRowModelModule,
  ColDef,
  GridApi,
  GridOptions,
  ModuleRegistry,
  ProcessFileInputParams,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ContextMenuModule,
  ExcelExportModule,
} from "ag-grid-enterprise";

if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

const modules = [
  ClientSideRowModelModule,
  AutoGenerateColumnsModule,
  ExcelExportModule,
  ColumnMenuModule,
  ContextMenuModule,
];

declare let XLSX: any;

const parseWorkbook: (workbook: any) => Record<string, unknown>[] = (
  workbook: any,
) => {
  const firstSheetName = workbook.SheetNames[0];
  const worksheet = workbook.Sheets[firstSheetName];
  return XLSX.utils.sheet_to_json(worksheet);
};

const GridExample = () => {
  const gridRef = useRef<AgGridReact>(null);
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);

  const defaultColDef = useMemo<ColDef>(() => {
    return {
      minWidth: 80,
      flex: 1,
    };
  }, []);
  const processFileInput = useCallback((params: ProcessFileInputParams) => {
    const file = params.files[0];
    if (!file) return;
    const reader = new FileReader();
    reader.onerror = () => params.fail("Failed to read file");
    reader.onload = (e) => {
      try {
        const workbook = XLSX.read(
          new Uint8Array(e.target?.result as ArrayBuffer),
        );
        params.success(parseWorkbook(workbook));
      } catch {
        params.fail("Failed to parse file");
      }
    };
    reader.readAsArrayBuffer(file);
  }, []);

  const uploadFile = useCallback(() => {
    const curr = gridRef.current!.api.getGridOption("activeOverlay");
    gridRef.current!.api.setGridOption(
      "activeOverlay",
      curr === "agFileInputOverlay" ? undefined : "agFileInputOverlay",
    );
  }, []);

  const importExcel = useCallback(() => {
    fetch("https://www.ag-grid.com/example-assets/olympic-data.xlsx")
      .then((response) => response.arrayBuffer())
      .then((data: ArrayBuffer) => {
        const workbook = XLSX.read(new Uint8Array(data));
        gridRef.current!.api.updateGridOptions({
          rowData: parseWorkbook(workbook),
          activeOverlay: undefined,
        });
      });
  }, []);

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div className="example-wrapper">
          <div style={{ marginBottom: "1rem" }}>
            <button onClick={importExcel}>Load Sample Excel</button>
            <button onClick={uploadFile}>Upload File</button>
          </div>

          <div style={gridStyle}>
            <AgGridReact
              ref={gridRef}
              autoGenerateColumnDefs={true}
              defaultColDef={defaultColDef}
              processFileInput={processFileInput}
            />
          </div>
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Import Excel into AG Grid](https://www.ag-grid.com/examples/excel-import/excel-import/reactFunctionalTs)


---
product: "AG Grid"
title: "Excel Import"
description: "Below we illustrate how you might import an Excel spreadsheet into AG Grid using a third-party library - in this example we're using ."
framework: angular
version: "36.2.0"
related:
    - title: "CSV Export"
      url: "https://www.ag-grid.com/angular-data-grid/csv-export/"
    - title: "Excel Export"
      url: "https://www.ag-grid.com/angular-data-grid/excel-export/"
    - title: "PDF Export"
      url: "https://www.ag-grid.com/angular-data-grid/pdf-export/"
    - title: "Clipboard"
      url: "https://www.ag-grid.com/angular-data-grid/clipboard/"
    - title: "Drag & Drop"
      url: "https://www.ag-grid.com/angular-data-grid/drag-and-drop/"
    - title: "Printing"
      url: "https://www.ag-grid.com/angular-data-grid/printing/"
llms: "https://www.ag-grid.com/llms.txt"
---

# Excel Import

Below we illustrate how you might import an Excel spreadsheet into AG Grid using a third-party library - in this example we're using [xlsx](https://www.jsdelivr.com/package/npm/xlsx).

[Auto-Generate Columns](https://www.ag-grid.com/angular-data-grid/auto-generate-columns/) is used so no column definitions need to be provided upfront — columns are created from the imported data. The `processFileInput` callback parses dropped Excel files using the same library.

Click **Load Sample Excel** to fetch a sample spreadsheet, or drag your own `.xlsx` file onto the grid. Click **Upload File** to re-show the file input overlay. The spreadsheet can also be downloaded [here](https://www.ag-grid.com/example-assets/olympic-data.xlsx).

## Example Import

#### Import Excel into AG Grid

```ts
import { Component } from "@angular/core";
import { AgGridAngular } from "ag-grid-angular";
import "./styles.css";
import {
  AutoGenerateColumnDefsOptions,
  AutoGenerateColumnsModule,
  ClientSideRowModelModule,
  ColDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  ProcessFileInputParams,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ContextMenuModule,
  ExcelExportModule,
} from "ag-grid-enterprise";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  AutoGenerateColumnsModule,
  ExcelExportModule,
  ColumnMenuModule,
  ContextMenuModule,
]);

declare let XLSX: any;

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<div class="example-wrapper">
    <div style="margin-bottom: 1rem">
      <button (click)="importExcel()">Load Sample Excel</button>
      <button (click)="uploadFile()">Upload File</button>
    </div>
    <ag-grid-angular
      style="width: 100%; height: 100%;"
      [autoGenerateColumnDefs]="true"
      [defaultColDef]="defaultColDef"
      [processFileInput]="processFileInput"
      [rowData]="rowData"
      (gridReady)="onGridReady($event)"
    />
  </div> `,
})
export class AppComponent {
  private gridApi!: GridApi;

  defaultColDef: ColDef = {
    minWidth: 80,
    flex: 1,
  };
  processFileInput: (params: ProcessFileInputParams) => void = (
    params: ProcessFileInputParams,
  ) => {
    const file = params.files[0];
    if (!file) return;
    const reader = new FileReader();
    reader.onerror = () => params.fail("Failed to read file");
    reader.onload = (e) => {
      try {
        const workbook = XLSX.read(
          new Uint8Array(e.target?.result as ArrayBuffer),
        );
        params.success(parseWorkbook(workbook));
      } catch {
        params.fail("Failed to parse file");
      }
    };
    reader.readAsArrayBuffer(file);
  };
  rowData!: any[];

  uploadFile() {
    const curr = this.gridApi.getGridOption("activeOverlay");
    this.gridApi.setGridOption(
      "activeOverlay",
      curr === "agFileInputOverlay" ? undefined : "agFileInputOverlay",
    );
  }

  importExcel() {
    fetch("https://www.ag-grid.com/example-assets/olympic-data.xlsx")
      .then((response) => response.arrayBuffer())
      .then((data: ArrayBuffer) => {
        const workbook = XLSX.read(new Uint8Array(data));
        this.gridApi.updateGridOptions({
          rowData: parseWorkbook(workbook),
          activeOverlay: undefined,
        });
      });
  }

  onGridReady(params: GridReadyEvent) {
    this.gridApi = params.api;
  }
}

function parseWorkbook(workbook: any): Record<string, unknown>[] {
  const firstSheetName = workbook.SheetNames[0];
  const worksheet = workbook.Sheets[firstSheetName];
  return XLSX.utils.sheet_to_json(worksheet);
}
```

[Live example: Import Excel into AG Grid](https://www.ag-grid.com/examples/excel-import/excel-import/angular/)


---
title: "Excel Import"
framework: vue
version: "36.1.0"
---

# Excel Import

Below we illustrate how you might import an Excel spreadsheet into AG Grid using a third-party library - in this example we're using [xlsx](https://www.jsdelivr.com/package/npm/xlsx).

[Auto-Generate Columns](https://www.ag-grid.com/vue-data-grid/auto-generate-columns/) is used so no column definitions need to be provided upfront — columns are created from the imported data. The `processFileInput` callback parses dropped Excel files using the same library.

Click **Load Sample Excel** to fetch a sample spreadsheet, or drag your own `.xlsx` file onto the grid. Click **Upload File** to re-show the file input overlay. The spreadsheet can also be downloaded [here](https://www.ag-grid.com/example-assets/olympic-data.xlsx).

## Example Import

#### Import Excel into AG Grid

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./styles.css";
import {
  AutoGenerateColumnDefsOptions,
  AutoGenerateColumnsModule,
  ClientSideRowModelModule,
  ColDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  ProcessFileInputParams,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ContextMenuModule,
  ExcelExportModule,
} from "ag-grid-enterprise";
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  AutoGenerateColumnsModule,
  ExcelExportModule,
  ColumnMenuModule,
  ContextMenuModule,
]);

declare let XLSX: any;

function parseWorkbook(workbook: any): Record<string, unknown>[] {
  const firstSheetName = workbook.SheetNames[0];
  const worksheet = workbook.Sheets[firstSheetName];
  return XLSX.utils.sheet_to_json(worksheet);
}

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <div class="example-wrapper">
      <div style="margin-bottom: 1rem">
        <button v-on:click="importExcel()">Load Sample Excel</button>
        <button v-on:click="uploadFile()">Upload File</button>
      </div>
      <ag-grid-vue
        style="width: 100%; height: 100%;"
        @grid-ready="onGridReady"
        :autoGenerateColumnDefs="true"
        :defaultColDef="defaultColDef"
        :processFileInput="processFileInput"
        :rowData="rowData"></ag-grid-vue>
      </div>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi | null>(null);
    const defaultColDef = ref<ColDef>({
      minWidth: 80,
      flex: 1,
    });
    const processFileInput = ref<(params: ProcessFileInputParams) => void>(
      (params: ProcessFileInputParams) => {
        const file = params.files[0];
        if (!file) return;
        const reader = new FileReader();
        reader.onerror = () => params.fail("Failed to read file");
        reader.onload = (e) => {
          try {
            const workbook = XLSX.read(
              new Uint8Array(e.target?.result as ArrayBuffer),
            );
            params.success(parseWorkbook(workbook));
          } catch {
            params.fail("Failed to parse file");
          }
        };
        reader.readAsArrayBuffer(file);
      },
    );
    const rowData = ref<any[]>(null);

    function uploadFile() {
      const curr = gridApi.value.getGridOption("activeOverlay");
      gridApi.value.setGridOption(
        "activeOverlay",
        curr === "agFileInputOverlay" ? undefined : "agFileInputOverlay",
      );
    }
    function importExcel() {
      fetch("https://www.ag-grid.com/example-assets/olympic-data.xlsx")
        .then((response) => response.arrayBuffer())
        .then((data: ArrayBuffer) => {
          const workbook = XLSX.read(new Uint8Array(data));
          gridApi.value.updateGridOptions({
            rowData: parseWorkbook(workbook),
            activeOverlay: undefined,
          });
        });
    }
    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;
    };

    return {
      gridApi,
      defaultColDef,
      processFileInput,
      rowData,
      onGridReady,
      uploadFile,
      importExcel,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Import Excel into AG Grid](https://www.ag-grid.com/examples/excel-import/excel-import/vue3)
